Index: branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Algorithms.GrammaticalOptimization/SequentialDecisionPolicies/GenericPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Algorithms.GrammaticalOptimization/SequentialDecisionPolicies/GenericPolicy.cs	(revision 12294)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Algorithms.GrammaticalOptimization/SequentialDecisionPolicies/GenericPolicy.cs	(revision 12295)
@@ -48,5 +48,8 @@
       foreach (var afterState in afterStates) {
         if (!Done(afterState)) {
-          activeAfterStates[idx] = GetValue(afterState);
+          if (GetTries(afterState) == 0) 
+            activeAfterStates[idx] = double.PositiveInfinity;
+          else
+            activeAfterStates[idx] = GetValue(afterState);
           actionIndexMap[idx] = originalIdx;
           idx++;
@@ -179,5 +182,5 @@
       Console.WriteLine(Q.Values.Max());
       var topTries = Q.Keys.OrderByDescending(key => T[key]).Take(50);
-      var topQs = Q.Keys.Where(key=>key.Contains(",")).OrderByDescending(key => Q[key]).Take(50);
+      var topQs = Q.Keys.Where(key => key.Contains(",")).OrderByDescending(key => Q[key]).Take(50);
       foreach (var t in topTries.Zip(topQs, Tuple.Create)) {
         var id1 = t.Item1;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Problems.GrammaticalOptimization/Problems/SymbolicRegressionPoly10Problem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Problems.GrammaticalOptimization/Problems/SymbolicRegressionPoly10Problem.cs	(revision 12294)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/HeuristicLab.Problems.GrammaticalOptimization/Problems/SymbolicRegressionPoly10Problem.cs	(revision 12295)
@@ -163,14 +163,14 @@
       //   .Concat(new Feature[] { new Feature(CanonicalRepresentation(phrase), 1.0) });
 
-      //return new Feature[] { new Feature(phrase, 1.0), };
-
-       var partialInterpreter = new PartialExpressionInterpreter();
-       var vars = new double[] { 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, };
-       var s = partialInterpreter.Interpret(phrase, vars);
-       //if (s.Any())
-       //  return new Feature[] { new Feature(s.Pop().ToString(), 1.0), };
-       //else
-       //  return new Feature[] { new Feature("$", 1.0), };
-       return new Feature[] { new Feature(string.Join(",", s), 1.0) };
+      return new Feature[] { new Feature(phrase, 1.0), };
+
+      // var partialInterpreter = new PartialExpressionInterpreter();
+      // var vars = new double[] { 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, };
+      // var s = partialInterpreter.Interpret(phrase, vars);
+      // //if (s.Any())
+      // //  return new Feature[] { new Feature(s.Pop().ToString(), 1.0), };
+      // //else
+      // //  return new Feature[] { new Feature("$", 1.0), };
+      // return new Feature[] { new Feature(string.Join(",", s), 1.0) };
     }
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/Main/Program.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/Main/Program.cs	(revision 12294)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization-gkr/Main/Program.cs	(revision 12295)
@@ -54,5 +54,5 @@
         //   new HeuristicLab.Algorithms.Bandits.GrammarPolicies.GenericGrammarPolicy(problem, new UCB1TunedPolicy()));
         var policy = new GenericPolicy(problem);
-        var alg = new SequentialSearch(problem, 23, random, 1,
+        var alg = new SequentialSearch(problem, 23, random, 0,
           policy);
         //var alg = new MonteCarloTreeSearch(problem, 23, random, new UCB1Policy(), new RandomSimulation(problem, random, 30));
@@ -71,6 +71,6 @@
             if (iterations % 1000 == 0) Console.Clear();
             Console.SetCursorPosition(0, 0);
-            // alg.PrintStats();
-            policy.PrintStats();
+             alg.PrintStats();
+            //policy.PrintStats();
           }
 